/*****************************************************************************/
/*     Generator - Sega Genesis emulation - (c) James Ponder 1997-1998       */
/*****************************************************************************/
/*                                                                           */
/* common.h                                                                  */
/*                                                                           */
/*****************************************************************************/

#define M68000 (000)
#define M68010 (010)
#define M68020 (020)
#define M68030 (030)
#define M68040 (040)
#define M68060 (060)

/* CPU to emulate */
#define EMU68K M68000

#define ALIGN (32)
#define ALIGN_PTR(x) (void *)((((uint32)x)+(ALIGN-1))&~(ALIGN-1))

/* compile.c */
extern uint8 *cc_test; /* cc_test[(type_of_test << 4) | flags] */
extern void *ptr;

#if 0

// Of some reason this doesn't work (compiler bug?)...
#define OPCODE ptr += 4; *((uint32 *)(ptr - 4))

#else

// And this should no longer be used...
#define OPCODE *((uint32 *)ptr)++

#endif

#ifdef IN_COMPILE_C
#define PC     (14)
#define REGS   (15)
#define SR     (16)
#define IPC    (17)
#define CLKS   (18)
#define TABLES (19)
#endif

/* FIXME: this should not be required */
#define CPUPTR (20) /* &cpu68k_clocks */
#define VDPPTR (21) /* &vdp_nextevent */

/* compiler_op.c */

/*
 * PPC Register mapping:
 *
 * 14      : 68000 PC
 * 15      : 68000 SR
 * 16 - 23 : 68000 D0-D7
 * 24 - 31 : 68000 A0-A7
 *
 *  3      : ARGUMENT TO/FROM FUNCTION
 *  4      : ARGUMENT TO FUNCTION
 *  5 -  6 : FLAG CALCULATION
 *  7 - 12 : WORK REGISTERS
 *
 */

#define PCREG (14)
#define DAREG (15) /* Pointer to Data and Address registers in memory */
#define SRREG (16)

#define TMP0  (22)
#define TMP1  (23)

void compile_make_block(t_ipclist *list);

