
/* i_ADD, i_ADDA, i_ADDX */

    case i_ADD:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      outval = 4; /* Use register 4 in case destination is a memory address */
      switch (iib->size) {
      case sz_byte:
        OPCODE = add(outval, dstval, srcval);
        break;
      case sz_word:
        OPCODE = add(outval, dstval, srcval);
        break;
      case sz_long:
        OPCODE = addc(outval, dstval, srcval);
        break;
      default:
        printf("i_ADD: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_addflag_v(iib, srcval, dstval, outval);
      if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X))
        compile_addflag_cx(iib, srcval, dstval, outval);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);
      break;

    case i_ADDA:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);
      compile_adval(iib, ipc, tp_dst, &outreg, -1);

      switch (iib->size) {
      case sz_word:
        OPCODE = extsh(srcval, srcval); /* Sign extend */
        break;
      case sz_long:
        break;
      default:
        printf("i_ADDA: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      OPCODE = add(outreg, outreg, srcval);
      compile_adstore(iib, ipc, tp_dst, outreg);
      break;

    case i_ADDX:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      outval = 4; /* Use register 4 in case destination is a memory address */
      switch (iib->size) {
      case sz_byte:
        OPCODE = rlwinm(0, SRREG, 12, 31, 31);
        OPCODE = add(outval, dstval, 0);
        OPCODE = add(outval, outval, srcval);
        break;
      case sz_word:
        OPCODE = rlwinm(0, SRREG, 12, 31, 31);
        OPCODE = add(outval, dstval, 0);
        OPCODE = add(outval, outval, srcval);
        break;
      case sz_long:
        OPCODE = rlwinm(0, SRREG, 12, 31, 31);
        OPCODE = addc(outval, dstval, 0);
        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
          OPCODE = li(0, 0);
          OPCODE = addze(0, 0);
        }
        OPCODE = addc(outval, outval, srcval);
        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
          OPCODE = addze(0, 0);
          OPCODE = rlwimi(SRREG, 0, 16, 15, 15);
          OPCODE = rlwimi(SRREG, 0, 20, 11, 11);
        }
        break;
      default:
        printf("i_ADDX: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_addflag_v(iib, srcval, dstval, outval);
      if (iib->size != sz_long) {
        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X))
          compile_addflag_cx(iib, srcval, dstval, outval);
      }
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdxflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);
      break;

