/* Generator is (c) James Ponder, 1997-2001 http://www.squish.net/generator/ */

#define OLD_TYPEDEFS
typedef float float32;
typedef double float64;

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#include "generator.h"
#include "gensound.h"
#include "gensoundp.h"
#include "vdp.h"
#include "ui.h"
#include "cpuz80.h"
#include "cli-amiga.h"

#if 1

#include "ahi.h"

/*** file scoped variables ***/

static int skipped = 0;

/*** soundp_start - start sound hardware ***/

int soundp_start(void)
{
  if ((cli_amiga.speedtest != SPEEDTEST_NONE) ||
     ((cpuz80_on == 0) && (sound_fm == 0) && (sound_psg == 0))) {
    return 0;
  } else {
    ahi_open(sound_speed, AUDIO_S16S, sound_sampsperfield << 1, sound_maxfields >> 1, NULL);
    skipped = 0;
    return 0;
  }
}

/*** soundp_stop - stop sound hardware ***/

void soundp_stop(void)
{
  if ((cli_amiga.speedtest != SPEEDTEST_NONE) ||
     ((cpuz80_on == 0) && (sound_fm == 0) && (sound_psg == 0))) {
  } else {
    ahi_close();
  }
}

/*** soundp_samplesbuffered - how many samples are currently buffered? ***/

int soundp_samplesbuffered(void)
{
#if 0
    return sound_threshold;
#else
  if ((cli_amiga.speedtest != SPEEDTEST_NONE) ||
     ((cpuz80_on == 0) && (sound_fm == 0) && (sound_psg == 0))) {
    return sound_threshold;
  } else {
    int pending = ahi_samples_buffered();

    if ((unsigned int)pending < sound_threshold) {
      skipped++;
    } else {
      skipped = 0;
    }

    /* don't skip too many frames in a row */
    if (skipped >= 10) {
      skipped = 0;
      return sound_threshold;
    } else {
      return pending;
    }
  }
#endif
}

void soundp_output(uint16 *left, uint16 *right, unsigned int samples)
{
  if ((cli_amiga.speedtest != SPEEDTEST_NONE) ||
     ((cpuz80_on == 0) && (sound_fm == 0) && (sound_psg == 0))) {
  } else {
    uint16 buffer[(SOUND_MAXRATE / 50) * 2]; /* pal is slowest framerate */
    int i;

    for (i = 0; i < samples; i++) {
      buffer[i * 2] = left[i];
      buffer[i * 2 + 1] = right[i];
    }

    ahi_play_samples(buffer, samples, NOTIME, NOWAIT);
  }
}

#else

/*** file scoped variables ***/

/*** soundp_start - start sound hardware ***/

int soundp_start(void)
{
  return 0;
}

/*** soundp_stop - stop sound hardware ***/

void soundp_stop(void)
{
}

/*** soundp_samplesbuffered - how many samples are currently buffered? ***/

int soundp_samplesbuffered(void)
{
  return sound_threshold;
}

void soundp_output(uint16 *left, uint16 *right, unsigned int samples)
{
}

#endif
